(document:surround "/std/base")
(document:envelop with-translation _ "alterator-printers")

width 500
height 500

title (_ "CUPS connection setup")

(set-global! 'printer-model (or (global 'printer-driver) (list "" "")))

(define (drop-header str)
  (and (string? str)
       (let ((size (string-length "http://")))
         (or
          (and (> (string-length str) size)
               (string-drop str size))
          ""))))

(define printer-uri (drop-header (global 'printer-uri)))

(define (extract-server str)
  (and (not-empty-string? str)
       (string-take str (string-index str #\:))))

(define (extract-printer str)
  (and (not-empty-string? str)
       (caddr (string-cut str #\/))))

(define (not-empty-field? f)
  (not-empty-string? (f text)))

(define (allow-ok)
	(and (not-empty-field? ipp-host)
             (not-empty-field? ipp-share)))

(define field-options (list
                            (when changed
                             (ok-button activity
			                (allow-ok)))))

(define (made-uri)
  (string-append
       "http://"
       (ipp-host text)
       ":631/printers/"
       (ipp-share text)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(vbox
 (hbox
  (label (_ "CUPS server:"))
  (document:id ipp-host (edit (or (extract-server printer-uri) "") field-options)))
 (hbox
  (label (_ "Printer name:"))
  (document:id ipp-share (edit (or (extract-printer printer-uri) "") field-options))))

(document:surround "/printers/mdl")

(hbox
      (document:id ok-button (button (_ "OK" )
				activity (and (not-empty-string? (ipp-host text))
					      (not-empty-string? (ipp-share text)))
                                (when clicked
                                  (document:end (cons (made-uri) (list (vendorlist text)
                                                                       (modellist text)
                                                                       (+ (modellist current) 1)))))))
      (button (_ "Cancel") (when clicked (document:end #f))))
