(document:surround "/std/base")
(document:envelop with-translation _ "alterator-printers")

width 500
height 500

title (_ "Local connection setup")

(define (get-devices)
  (woo-catch/message
   (thunk
     (woo-list-names "/printer_detect"))))

(set-global! 'printer-model (or (global 'printer-driver) (list "" "")))
(set-global! 'load-auto (make-cell #f))

(define printer-uri (make-cell (or (global 'printer-uri) "")))

(define (getdevice name)
  (woo-catch/message
   (thunk
    (woo-read-first (string-append "/printer_detect/" name)))))

(define (get-current devices-lst)
  (list-index (lambda(x)
                (let* ((device (getdevice x))
                       (uri (woo-get-option device 'uri)))
                  (string=? uri (cell-ref printer-uri))))
              devices-lst))

(define (make-uri uri)
  (if (bind-serial state)
    uri
    (string-take uri (or (string-index uri #\?)
                         (string-length uri)))))

(hbox (label (_ "Detected printer:")) (document:id auto-detect (label "")))
(document:id devicelist (listbox header (vector (_ "Devices"))
                                 (when selected
                                   (let* ((device (getdevice (devicelist text)))
                                          (driver (woo-get-option device 'driver #f))
                                          (driver-lst (and driver (string-cut driver #\;)))
                                          (uri (woo-get-option device 'uri))
                                          (make_n_model (woo-get-option device 'make_model "")))
                                     (auto-detect text make_n_model)
                                     (and driver
                                          (begin
                                            (set-global! 'printer-model
                                                         (list (car driver-lst)
                                                               (cadr driver-lst)))
                                            ((cell-ref (global 'load-auto)))))
                                     (cell-set! printer-uri uri)))))

(document:id bind-serial (checkbox (_ "Bind to serial number")))

(document:surround "/printers/mdl")

(hbox
      (button (_ "OK") (when clicked (document:end (cons (make-uri (cell-ref printer-uri))
                                                         (list (vendorlist text)
                                                               (modellist text)
                                                               (+ (modellist current) 1))))))
      (button (_ "Cancel") (when clicked (document:end #f))))

(document:root
  (when loaded
   (devicelist (let ((devices (or (get-devices) '())))
                 (list (rows devices)
                       (current (or (get-current devices) -1)))))))
