(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-printers")

(define (get-vendors)
  (woo-catch/message
   (thunk
     (woo-list-names "/cupsd/drv-vendors"))))

(define (get-models name)
  (woo-catch/message
   (thunk
     (woo-list-names (string-append "/cupsd/" name)))))

(define (auto-select auto-item lst)
  (and auto-item
       (string-list-index auto-item lst)))

(define (load-auto)
  (let* ((printer-model (global 'printer-model))
         (auto-vendor (cond-car printer-model))
         (auto-model (cond-cadr printer-model))
         (vendors (get-vendors))
         (auto-vendor-num (or (auto-select auto-vendor vendors) 0))
         (models (if (null? vendors)
                     '()
                     (get-models (list-ref vendors auto-vendor-num))))
         (auto-model-num (or (auto-select auto-model models) 0)))
    (vendorlist rows vendors
                current auto-vendor-num)
    (modellist rows models
               current auto-model-num)))

;;;;;;;;;;;;;;;;;;;;;;

(hbox
      (label (_ "Printer Model:"))
      (document:id vendorlist
                   (combobox
                             (when selected
                               (modellist rows (get-models (vendorlist text))
                                          current 0)
                               ))))
(document:id modellist
             (listbox
                      header (vector (_ "Model Name"))))
;;;;;;;;;;;;;;;;;;;;;;;

(document:root
  (when loaded
   (load-auto)
   (and (global 'load-auto) (cell-set! (global 'load-auto) load-auto))))
