(document:surround "/std/base")
(document:envelop with-translation _ "alterator-printers")

width 500
height 500

title (_ "Network printer (print server) connection setup")

(set-global! 'printer-model (or (global 'printer-driver) (list "" "")))

(define (drop-header str)
  (and (string? str)
       (let ((size (string-length "socket://")))
         (or
          (and (> (string-length str) size)
               (string-drop str size))
          ""))))

(define printer-uri (drop-header (global 'printer-uri)))

(define (not-empty-field? f)
  (not-empty-string? (f text)))

(define (allow-ok)
	(not-empty-field? print-server))

(define field-options (list
                            (when changed
                             (ok-button activity
			                (allow-ok)))))

(define (made-uri)
  (string-append
       "socket://"
       (print-server text)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(vbox
 (hbox
  (label (_ "Printer ip address (or dns-name):"))
  (document:id print-server (edit (or printer-uri "") field-options)))
)

(document:surround "/printers/mdl")

(hbox
      (document:id ok-button (button (_ "OK" )
				activity (not-empty-string? (print-server text))
                                (when clicked
                                  (document:end (cons (made-uri) (list (vendorlist text)
                                                                       (modellist text)
                                                                       (+ (modellist current) 1)))))))
      (button (_ "Cancel") (when clicked (document:end #f))))
